/***************************************************************************
 *  SEABAS Control base class "SiTCP_Cnt"
 *  
 *  File        : SiTCP_cnt.h
 *  version     : v 1.0.0 2008/11/5
 *  Author      : Minoru Hirose
 *
 *  Description : class SiTCP_Cnt definition
 *                
 ***************************************************************************/
#ifndef SiTCP_CNT_H
#define SiTCP_CNT_H

#include<iostream>

#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<unistd.h>
#include<errno.h>

#include<sys/types.h>
#include<sys/stat.h>
#include<sys/socket.h>
#include<sys/select.h>
#include<netinet/in.h>
#include<arpa/inet.h>

struct bcp_header{
  unsigned char type;
  unsigned char command;
  unsigned char id;
  unsigned char length;
  unsigned int address;
};

class SiTCP_Cnt{
 private:
  const char* sitcpIpAddr;
  unsigned int tcpPort;
  unsigned int udpPort;
  int udpsock;
  int tcpsock;
  struct bcp_header sndHeader;

 public:
  struct sockaddr_in tcpAddr;
  struct sockaddr_in udpAddr;
  struct timeval timeout;
  fd_set rmask, wmask, fds, readfds;
  unsigned char sndBuf[2048];
  unsigned char sndData[256];
  unsigned short tmp[128][128];
  void RBCPskeleton(unsigned char type, unsigned char command, unsigned char id,
		    unsigned char length, unsigned char address);
  int rcvRBCP_ACK(int output);

  SiTCP_Cnt();
  ~SiTCP_Cnt();
  bool SetIPPort(const char* IpAddr, unsigned int tcp, unsigned int udp);
  int CreateTCPSock();
  int CreateUDPSock();
  bool CloseTCPSock();
  bool CloseUDPSock();

  int GetTCPSock() const {return tcpsock;}
  int GetUDPSock() const {return udpsock;}
  bcp_header GetsndHeader() const {return sndHeader;}
};

class Intpix_Data
{
 public:
  unsigned int event;
  bool calib;
  unsigned short IntTime;
  unsigned short RSTLength;
  unsigned short ScanTime;
  unsigned short RSTV;
  unsigned short adc[128][128];
};

#endif
